#include <stdio.h>
#include <string.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

static char RES='!';

void todir(char* name)
{
 DIR* dir;
 struct dirent* file;
 struct stat st;
 char buf[512]; 

 dir = opendir(name);
 if( !dir ){ fprintf(stderr,"nodir: %s\n", name); return;}

 while( file = readdir(dir) )
 {
  if( strcmp(file->d_name,"..")==0 || strcmp(file->d_name,".")==0 ) continue;
  
  strcpy(buf,name);
  strcat(buf,"/");
  strcat(buf,file->d_name);

  stat(buf, &st);
  if( S_ISDIR(st.st_mode) )  
  {
// printf("dir: %s\n", buf);
   todir(buf);
  }
  else
  {
   char buff[1024*1024];
   char* s;
   int fd, i, q;

   fd = open(buf,O_RDONLY);
   if( !fd ){ fprintf(stderr,"file no open `%s'\n",buf); continue;}
   
   printf("%s\n",buf);
   
   for(s=buf; *s; s++) if(*s=='/') *s=RES;
   
   s = strchr(buf,RES)+1;
      
   q = open(s, O_WRONLY | O_CREAT);
   if( !q ){ fprintf(stderr,"file no creat `%s'\n",buf); close(fd); continue;}
   
   while( i = read(fd,buff,1024*1024) ) write(q,buff,i);
   close(fd);
   close(q);
  }
 }
 closedir(dir);
}

main(int ac, char** av)
{
 if( ac < 2 || ac > 3) fprintf(stderr,"use: d2f <dir> [<char>='!']\n"), exit(1);
 if( ac == 3 ) 
 {
  if( strlen(av[2])!=1 ) fprintf(stderr,"<char> to many long\n"), exit(1);
  RES = *av[2];
 }
 
 todir(av[1]);
}
